     Shiruri
     ~~~~~~~

  Un shir este o variabila in care putem retzine simultan mai multe valori.
Ele sunt retzinute dupa un "indice" (nr. de ordine, potzitzie).

  Se declara prin:
     tip nume_shir[nr_elemente];
Ex:
   int a[4];  -> shirul a va avea 4 elemente de tip int.
Indicii posibili sunt de la 0 la nr_elemente-1.
  In cazul de fatza - 0..3

!! atunci cind declaram, nr_elemente tre' sa fie un NUMAR CONSTANT (deci NU
putem declara cu variabila) !!

 Elementele sale sunt
  a[0] a[1] a[2] a[3]
fiecare se comporta EXACT ca shi un intreg.

  Programele stas, cind citesc un shir procedeaza astfel:
- citesc intr-o variabila numarul de elemente din shir
- citesc, pe un for, elementele shirului, rind pe rind.
Exista 2 stiluri de programare:
  * standard (teoria algoritmilor) - folosim indici de la 1 la n
(elementul a[0], deshi face parte in mod natural din shir, NU il vom folosi)
  * C style - folosim indici de la 0 la n-1 -> acest stil este recomandat
    DOAR dupa o experientza mai indelungata

Iata un exemplu:
~~~~~~~~~~~~~~~~

int n,a[30];
//declarind a[30] avem indici posibil de la 0..29
//daca lucram cu indici pornind de la 1, tre' sa avem grija ca in shir SA NU
//folosim mai mult de 29 de elemente.
//!! Folosirea unui nr. mai mare de elemente decit in declaratzie, poate duce
//la ieshirea din memoria alocata programului; in cel mai bun caz ne trezim
//ca facind o atribuire de genul a[50] (pe ex. de mai sus) ne modifica o cu
//totul alta varibaila, sau in cel mai rau caz ca programul crapa
cout<<"Introdu numarul de elemente din shirutz:";
cin>>n;
for(i=1;i<=n;i++)
 {
  cout<<"Vira elementul de la indicele "<<i<<":";
  cin>>a[i];
 }

Afisharea, se face shi ea, evident, TOT pe un for:

for(i=1;i<=n;i++)
  cout<<a[i]<<" ";
cout<<"\n";

 Vezi apl01.cpp, apl02.cpp
====================================================================
Cautarea unui element in shir shi determinarea indicelui sau (prima aparitzie)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Ex:
Fie shirul a=(11,5,13,2,4,2,9)
 shi cautam prima valoare care este numar par.

Raspuns: gasit, indicele este=4

Secventzele de program le gindim pe o cautare in shirul a cu n elemente.

Secventza:
~~~~~~~~~~
A) Forma cea mai eleganta, insa care NU merge daca este sa cautam elemente
cu proprietatzi mai complicate, care sa NU se poata scrie intr-o conditzie
de tipul expresie logica: pe while.

 General:
    ind=1;
    while( (mai avem unde cauta<=>ind e inca valabil)&&
	      (elem. curent NU are proprietatea ceruta) )
			       ind++;//cautam mai departe
// pentru a determina shi daca am gasit sau nu
    if(ind>nr_elemente_din_shir)
		    cout<<"N-am gasit";
    else
       cout<<"Am gasit la indicele "<<ind;

Pe asta cu parele

  ind=1;
  while(ind<=n && a[ind]%2!=0)
			   ind++;
//=> while-ul se opreshte fie knd ind>n,deci N-am gasit
//   fie knd a[ind]%2!=0   e FALSA, adik atunci knd a[ind] este par

Vezi apl03.cpp,apl04.cpp

B) Cautarea pe un for cu break - se aplica atunci cind elementul PE care il
cautam e mai dificil de determinat <=> avem nevoie de mai mult decit o simpla
conditzie de tip expresie logica.

Forma:
ind=-1;   //initzial bag -1, pentru ca in final sa-mi pot da seama
	  //de-am gasit au ba
for(i=1;i<=n;i++)//iau tot shirul la puricat
  {
    ....determinari suplimentare....
    if( a[i] este elementul pe care il caut )
			  {
			   ind=i;//retzin indicele lui in variabila ind
			   break;//intrerupe for-ul fortzat.
			  }
  }
if(ind==-1) cout<<"Nu am gasit";
else cout<<"Am gasit, indicele fiind "<<ind;

apl05.cpp
==============================================================
  Formarea unui shir
  ~~~~~~~~~~~~~~~~~~

* se ia o variabila in care sa retzinem nr. de elemente din shirul pe care
il formam. Initzial in aceasta variabila punem 0 (semn ca shirul are 0
elemente, adik initzial e vid). Ex: p=0;
* fiecare NOUA adaugare a unui element la coada se face prin:
     (fie b = shirul nou format)
   p++;
   b[p]=valoarea_cea_noua.

Sau, mai pe scurt, tzinind cont de capabilitatzile C++ -ului

+----------------------------+
|  b[++p]=valoarea_cea_noua; |
+----------------------------+
b[++p] inseamna ca mai intii creshte valoarea din p, shi apoi, cu valoarea
gata crescuta se face restul.
Vezi apl06.cpp
==============================================================
  Shtergerea unui element dintr-un shir, de la un indice dat
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Ex:
 a=(10,5,8,7,3,2,9) cu n=7 elemente
Shi vrem sa shtergem elementul de la indicele k=4
=> dupa shtergere:
	a=(10,5,8,3,2,9)

 Ce facem ?
    elementele de la indicii 1..3 le lasam in pace
    Elementele dintre indicii 5..7 tre' aduse cu 1 poz. la stinga
---
 Pe cazul general, elementelor dintre indicii 1..k-1 le dam pace
 Elementele dintre indicii k+1 shi n le aducem cu o poz. la stinga.
Deci
    a[k] <- a[k+1]     TOATE acestea se fac f. simplu pe un for:
  a[k+1] <- a[k+2]
  a[k+2] <- a[k+3]         for(i=k+1;i<=n;i++)
  ...                                    a[i-1]=a[i];
  a[n-2] <- a[n-1]
  a[n-1] <- a[n]

Dupa ce fac acste mutari, mai tre' acutalizat shi n, pentru ca shirul a
pierdut un element.

DECI:
 secventza care shterge elem. de la indicele k:
     +-------------------------+
     | for(i=k+1;i<=n;i++)     |
     |		 a[i-1]=a[i];  |
     | n--;                    |
     +-------------------------+

Vezi apl07.cpp
==============================================================
  Inserarea unei valori intr-un shir, la un indice dat
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Ex:
Ex:
 a=(10,5,8,7,3,2,9) cu n=7 elemente
Shi vrem sa inseram la indicele k=4 valoare 69
=> dupa inserare:
	a=(10,5,8,69,7,3,2,9)

 Ce facem ?
   -> elementelor dintre indicii 1..3 le dam pace
   -> elementele dintre indicii 4..7 tre' mutate cu o pozitzie la dreapta.
   In locul ramas (a[4]) dupa mutare, aducem elementul dorit.
De data asta, mutarile tre' facute de la coada (de la dreapta la stinga)
adik prima oara sa aducem elem a[n] cu 1 poz la dreapta, apoi abia a[n-1] cu
o poz. la dreapta, etc.
 (!! daca ash face mutarile in ordine crescatoare, m-ash trezi cu valoarea
 din a[4] in toate elementele)

Deci, pe cazul general tre' sa fac mutarile urmatoare:
   a[n+1]=  a[n]
     a[n]=a[n-1]   adik. pe un for:
   a[n-1]=a[n-2]          for(i=n;i>=k;i--)
   ...                                 a[i+1]=a[i];
   a[k+2]=a[k+1]
   a[k+1]=  a[k]
--
 tre' sa nu uitam sa actualizam n-ul:
	 n++;  //shirul a cishtigat un element
 shi la indicele k sa bag valoarea cea noua:
 a[k]=valoarea noua;

Deci, secv. pt. inserarea valorii vvv la indicele k e urmatoarea:
     +-------------------------+
     | for(i=n;i>=k;i--)       |
     |		 a[i+1]=a[i];  |
     | n++;                    |
     | a[k]=vvv;               |
     +-------------------------+

vezi apl08.cpp
============================================================
